# Intended to work with \dm\bin\make.exe

#DFLAGS =       -g -O -release
DFLAGS =        -g

VERSION =	release_1-3
ZIP =           7z a -tzip 

DM =            /
DMD =           $(DM)dmd/bin/dmd
LIB =           $(DM)dm/bin/lib
LIB_DIR =       $(DM)dmd/lib
OBJ =           ./obj/
EXPORT =	\dmd\src\export
CLEAN =		del 
COPY =		copy 

MANGO =         mango
EXAMPLE =       example/
BASE =          $(MANGO)/base/
TEST =          $(MANGO)/test/
UTILS =         $(MANGO)/utils/
UTILSMODEL =    $(MANGO)/utils/model/
IO =            $(MANGO)/io/
IOMODEL =       $(MANGO)/io/model/
CACHE =         $(MANGO)/cache/
CACHEMODEL =    $(MANGO)/cache/model/
SERVERMODEL =   $(MANGO)/http/server/model/
HTTPCLIENT =    $(MANGO)/http/client/
HTTP =          $(MANGO)/http/
HTTPUTILS =     $(MANGO)/http/utils/
HTTPSERVER =    $(MANGO)/http/server/
SERVLET =       $(MANGO)/servlet/
SERVLETMODEL =  $(MANGO)/servlet/model/
LOG =           $(MANGO)/log/
LOGMODEL =      $(MANGO)/log/model/
CLUSTER =       $(MANGO)/cluster/
CLUSTERMODEL =  $(MANGO)/cluster/model/
CLUSTERSOCKET = $(MANGO)/cluster/qos/socket/
ICU =           $(MANGO)/icu/
FORMAT =        $(MANGO)/format/

COMPILE =       $(DMD) -c 


SRC_EXAMPLE = \
        $(EXAMPLE)alert.d\
        $(EXAMPLE)cclient.d\
        $(EXAMPLE)cserver.d\
        $(EXAMPLE)filecat.d\
        $(EXAMPLE)filecopy.d\
        $(EXAMPLE)lineio.d\
        $(EXAMPLE)filescan.d\
        $(EXAMPLE)logging.d\
        $(EXAMPLE)pickle.d\
        $(EXAMPLE)randomio.d\
        $(EXAMPLE)servlets.d\
        $(EXAMPLE)tserver.d\

SRC_FORMAT = \
        $(FORMAT)Int.d \
        $(FORMAT)Long.d \
        $(FORMAT)Double.d \
        $(FORMAT)Number.d \
        $(FORMAT)DateTime.d \
        $(FORMAT)DGDouble.d \
        $(FORMAT)Formatter.d \

SRC_IO = \
        $(BASE)System.d \
        $(BASE)ByteSwap.d \
        $(UTILS)Timer.d \
        $(UTILS)Text.d \
        $(UTILS)Random.d \
        $(UTILS)HeapSlice.d \
        $(UTILS)AbstractServer.d \
        $(UTILS)ServerThread.d \
        $(UTILSMODEL)IServer.d \
        $(IOMODEL)IBuffer.d \
        $(IOMODEL)IResource.d \
        $(IOMODEL)IConduit.d \
        $(IOMODEL)IReader.d \
        $(IOMODEL)IWriter.d \
        $(IOMODEL)IPickle.d \
        $(IOMODEL)IBitBucket.d \
        $(IO)ArrayAllocator.d \
        $(IO)TextFormat.d \
        $(IO)TextLayout.d \
        $(IO)Exception.d \
        $(IO)File.d \
        $(IO)FileConst.d \
        $(IO)FileStyle.d \
        $(IO)FilePath.d \
        $(IO)FileScan.d \
        $(IO)ConduitStyle.d \
        $(IO)Conduit.d \
        $(IO)Buffer.d \
        $(IO)Resource.d \
        $(IO)FileSystem.d \
        $(IO)FileConduit.d \
        $(IO)FileProxy.d \
        $(IO)EndianReader.d \
        $(IO)EndianWriter.d \
        $(IO)Token.d \
        $(IO)Tokenizer.d \
        $(IO)TextWriter.d \
        $(IO)TextReader.d \
        $(IO)DisplayWriter.d \
        $(IO)ColumnWriter.d \
        $(IO)Stdin.d \
        $(IO)Stdout.d \
        $(IO)AbstractReader.d \
        $(IO)AbstractWriter.d \
        $(IO)Reader.d \
        $(IO)Writer.d \
        $(IO)Socket.d \
        $(IO)PickleRegistry.d \
        $(IO)PickleReader.d \
        $(IO)PickleWriter.d \
        $(IO)FileBucket.d \
        $(IO)Uri.d \
        $(IO)SocketConduit.d \
        $(IO)ServerSocket.d \
        $(IO)DatagramSocket.d \
        $(IO)MulticastSocket.d \
        $(IO)SocketListener.d \
        $(IO)Properties.d \
        $(IO)Utf8.d \


SRC_CACHE = \
        $(CACHEMODEL)ICache.d \
        $(CACHEMODEL)IPayload.d \
        $(CACHE)HashMap.d \
        $(CACHE)PlainCache.d \
        $(CACHE)Payload.d \
        $(CACHE)QueuedCache.d \
        $(CACHE)VirtualCache.d \


SRC_HTTP = \
        $(SERVERMODEL)IProvider.d \
        $(SERVERMODEL)IProviderBridge.d \
        $(HTTP)HttpReader.d \
        $(HTTP)HttpWriter.d \
        $(HTTPUTILS)TokenStack.d \
        $(HTTPUTILS)Dictionary.d \
        $(HTTPSERVER)HttpTokens.d \
        $(HTTPSERVER)HttpParams.d \
        $(HTTPSERVER)HttpHeaders.d \
        $(HTTPSERVER)HttpCookies.d \
        $(HTTPSERVER)HttpBridge.d \
        $(HTTPSERVER)HttpMessage.d \
        $(HTTPSERVER)HttpRequest.d \
        $(HTTPSERVER)HttpResponse.d \
        $(HTTPSERVER)HttpProvider.d \
        $(HTTPSERVER)HttpServer.d \
        $(HTTPSERVER)HttpThread.d \
        $(HTTPCLIENT)HttpClient.d \


SRC_SERVLET = \
        $(SERVLETMODEL)IServletRequest.d \
        $(SERVLETMODEL)IServletResponse.d \
        $(SERVLET)ServletConfig.d \
        $(SERVLET)Servlet.d \
        $(SERVLET)ServletRequest.d \
        $(SERVLET)ServletResponse.d \
        $(SERVLET)ServletProvider.d \
        $(SERVLET)ServletContext.d \

SRC_LOG = \
        $(LOGMODEL)ILevel.d \
        $(LOGMODEL)ILogger.d \
        $(LOG)Admin.d \
        $(LOG)Hierarchy.d \
        $(LOG)Manager.d \
        $(LOG)Logger.d \
        $(LOG)Event.d \
        $(LOG)Layout.d \
        $(LOG)XmlLayout.d \
        $(LOG)DateLayout.d \
        $(LOG)Appender.d \
        $(LOG)SocketAppender.d \
        $(LOG)Configurator.d \
        $(LOG)FileAppender.d \
        $(LOG)RollingFileAppender.d \
        $(LOG)ConsoleAppender.d \


SRC_CLUSTER = \
        $(CLUSTERMODEL)ICluster.d \
        $(CLUSTERMODEL)IChannel.d \
        $(CLUSTERMODEL)IEvent.d \
        $(CLUSTERMODEL)IMessage.d \
        $(CLUSTERMODEL)IConsumer.d \
        $(CLUSTER)Client.d \
        $(CLUSTER)CacheInvalidator.d \
        $(CLUSTER)CacheInvalidatee.d \
        $(CLUSTER)NetworkCache.d \
        $(CLUSTER)NetworkQueue.d \
        $(CLUSTER)NetworkAlert.d \
        $(CLUSTER)Message.d \
        $(CLUSTER)TaskServer.d \
        $(CLUSTERSOCKET)ProtocolWriter.d \
        $(CLUSTERSOCKET)ProtocolReader.d \
        $(CLUSTERSOCKET)Cluster.d \
        $(CLUSTERSOCKET)RollCall.d \
        $(CLUSTERSOCKET)ClusterEvent.d \
        $(CLUSTERSOCKET)ClusterThread.d \
        $(CLUSTERSOCKET)ClusterServer.d \
        $(CLUSTERSOCKET)ClusterCache.d \


SRC_ICU = \
        $(ICU)ICU.d \
        $(ICU)UChar.d \
        $(ICU)ULocale.d \
        $(ICU)UConverter.d \
        $(ICU)UString.d \
        $(ICU)USearch.d \
        $(ICU)UTimeZone.d \
        $(ICU)UCalendar.d \
        $(ICU)UDateFormat.d \
        $(ICU)UNumberFormat.d \
        $(ICU)UBreakIterator.d \
        $(ICU)UResourceBundle.d \
        $(ICU)UMessageFormat.d \
        $(ICU)UTransform.d \
        $(ICU)UNormalize.d \
        $(ICU)UStringPrep.d \
        $(ICU)UDomainName.d \
        $(ICU)UMango.d \
        $(ICU)USet.d \
        $(ICU)UCollator.d \
        $(ICU)UEnumeration.d \
        $(ICU)URegex.d \


all :                   log.lib icu.lib mango.lib log_r.lib icu_r.lib mango_r.lib

test :                  mango.lib $(TEST)unittest.d 
                        $(DMD) $(DFLAGS) -of.\mango\test\unittest.exe $(TEST)unittest.d $(TEST)dtoa.obj wsock32.lib mango.lib
                        $(CLEAN) *.obj *.map

package :		log.lib icu.lib mango.lib log_r.lib icu_r.lib mango_r.lib \
			zip\log.zip zip\icu.zip zip\example.zip zip\mango.zip \
			doc

#documentation 

doc :
			cd doc
			doxygen mango.txt
			cd ..
			$(ZIP) -bd mango_$(VERSION)_doc.zip doc/*.* doc/html/*.*
			copy mango*.zip $(EXPORT)
			$(CLEAN) *.zip 
			rd /q /s doc\html

#zip files 

zip\log.zip :		$(SRC_LOG)
			$(CLEAN) $@ 
			$(ZIP) $@ $** log*.lib
			$(COPY) $@ $(EXPORT)\mango_$(VERSION)_log.zip

zip\icu.zip :		$(SRC_ICU)
			$(CLEAN) $@ 
			$(ZIP) $@ $** icu*.lib
			$(COPY) $@ $(EXPORT)\mango_$(VERSION)_icu.zip

zip\example.zip :	$(SRC_EXAMPLE)
			$(CLEAN) $@ 
			$(ZIP) $@ $** $(EXAMPLE)*.make
			$(COPY) $@ $(EXPORT)\mango_$(VERSION)_example.zip

zip\mango.zip :         $(SRC_FORMAT) $(SRC_IO) $(SRC_CACHE) $(SRC_HTTP) $(SRC_LOG) $(SRC_CLUSTER) $(SRC_ICU) $(SRC_SERVLET)
			$(CLEAN) $@ 
			$(ZIP) $@ $** mango*.lib win32.make linux.make darwin.make readme.txt make/*.*
			$(COPY) $@ $(EXPORT)\mango_$(VERSION).zip


#debug libraries

log.lib :               $(SRC_LOG)
                        $(COMPILE) -g -version=Isolated $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

icu.lib :               $(SRC_ICU)
                        $(COMPILE) -g -version=Isolated $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

mango.lib :             $(SRC_FORMAT) $(SRC_IO) $(SRC_CACHE) $(SRC_HTTP) $(SRC_LOG) $(SRC_CLUSTER) $(SRC_ICU) $(SRC_SERVLET)
                        $(COMPILE) -g $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

# release libraries

log_r.lib :             $(SRC_LOG)
                        $(COMPILE) -release -O -version=Isolated $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

icu_r.lib :             $(SRC_ICU)
                        $(COMPILE) -release -O -version=Isolated $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

mango_r.lib :           $(SRC_FORMAT) $(SRC_IO) $(SRC_CACHE) $(SRC_HTTP) $(SRC_LOG) $(SRC_CLUSTER) $(SRC_ICU) $(SRC_SERVLET)
                        $(COMPILE) -release -O $**
                        dir *.obj /b > mango.rsp
                        $(LIB) -c -n -p256 $@ @mango.rsp
                        $(CLEAN) *.rsp *.obj

